/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */

package bandit.Model.Generator;

import bandit.Model.Zahlengenerator;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Flow.Subscriber;
import java.util.concurrent.SubmissionPublisher;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.logging.Logger;
import bandit.util.OhmLogger;

/**
 *
 * @author le
 */
public class Generator2 implements Runnable // Callable
{
  private static Logger lg = OhmLogger.getLogger(); //Logger sollten immer static sein da sie für alle instanzen loggs ausführen
  
  private Integer[] wert;
  private volatile boolean laufend;
  private ExecutorService eService;
  
  private final Object LOCK;
  
  private SubmissionPublisher<Integer[]> wertPublisher;
  
  public Generator2(Zahlengenerator hauptgenerator)
  {
    wert = new Integer[2];
    wert[0] = -1;
    wert[1] = 2;
    
    laufend = false;
    eService = Executors.newSingleThreadExecutor();
    wertPublisher = new SubmissionPublisher<>();
    this.addWertSubscription(hauptgenerator);
    LOCK = new Object();
  }
  
  public void addWertSubscription(Subscriber<Integer[]> subscriber)
  {
    wertPublisher.subscribe(subscriber);
  }
  
  public void start()
  {
    laufend = true;
    synchronized (LOCK)
    {
      LOCK.notify();
    }
    
    
    if (eService.isShutdown())
    {
      eService = Executors.newSingleThreadExecutor();
    }
    eService.execute(this);
  }
  
  public void stop()
  {
      synchronized(LOCK){
        laufend = false;
      }
  }

  @Override
  public void run()
  {
    while (true)
    {
      while (!laufend)
      {
        synchronized (LOCK)
        {
          try
          {
            lg.info("WAIT");
            LOCK.wait();
          }
          catch (InterruptedException ex)
          {
            lg.warning(ex.toString());
          }
        }
      }
         
      try
      {
        Thread.sleep(100);
      }
      catch (Exception ex)
      {
        System.err.println(ex);
      }
      this.berechneWert();
      wertPublisher.submit(wert);
    }
  }

  private synchronized void berechneWert()
  {
    wert[0] = (int) (1 + 6*Math.random());
  }

  
}
